package com.sun.org.apache.bcel.internal.classfile;

import java.io.DataOutputStream;
import java.io.IOException;
import java.io.DataInput;

public final class ConstantLong extends Constant implements ConstantObject
{
    private long bytes;
    
    public ConstantLong(long bytes) {
        super((byte)5);
        this.bytes = bytes;
    }
    
    public ConstantLong(ConstantLong c) {
        this(c.getBytes());
    }
    
    ConstantLong(DataInput file) throws IOException {
        this(file.readLong());
    }
    
    @Override
    public void accept(Visitor v) {
        v.visitConstantLong(this);
    }
    
    @Override
    public final void dump(DataOutputStream file) throws IOException {
        file.writeByte((int)super.getTag());
        file.writeLong(this.bytes);
    }
    
    public final long getBytes() {
        return this.bytes;
    }
    
    public final void setBytes(long bytes) {
        this.bytes = bytes;
    }
    
    @Override
    public final String toString() {
        return super.toString() + "(bytes = " + this.bytes + ")";
    }
    
    @Override
    public Object getConstantValue(ConstantPool cp) {
        return Long.valueOf(this.bytes);
    }
}
